## frama-c 20220511

=== Makefile ===
##########################################################################
#                                                                        #
#  This file is part of Frama-C.                                         #
#                                                                        #
#  Copyright (C) 2007-2022                                               #
#    CEA (Commissariat à l'énergie atomique et aux énergies              #
#         alternatives)                                                  #
#                                                                        #
#  you can redistribute it and/or modify it under the terms of the GNU   #
#  Lesser General Public License as published by the Free Software       #
#  Foundation, version 2.1.                                              #
#                                                                        #
#  It is distributed in the hope that it will be useful,                 #
#  but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#  GNU Lesser General Public License for more details.                   #
#                                                                        #
#  See the GNU Lesser General Public License version 2.1                 #
#  for more details (enclosed in the file licenses/LGPLv2.1).            #
#                                                                        #
##########################################################################

# This file is the main makefile of Frama-C.

FRAMAC_SRC=.
MAKECONFIG_DIR=share
PLUGIN_TESTS_LIST:=
include share/Makefile.common
include share/Makefile.dynamic_config.internal

#Check share/Makefile.config available
ifndef FRAMAC_ROOT_SRCDIR
$(error \
  "You should run ./configure first (or autoconf if there is no configure)")
endif

###################
# Frama-C Version #
###################

VERSION:=$(shell $(CAT) VERSION)
VERSION_SAFE=$(subst ~,-,$(VERSION))
VERSION_CODENAME:=$(shell $(CAT) VERSION_CODENAME)

###########################
# Global plugin variables #
###########################

# the directory where compiled plugin non-GUI files are stored
PLUGIN_TOP_LIB_DIR= $(PLUGIN_LIB_DIR)/top

# the directory where compiled plugin GUI files are stored
PLUGIN_GUI_LIB_DIR= $(PLUGIN_LIB_DIR)/gui

# the directory where the other Makefiles are
FRAMAC_SHARE	= share

# Shared lists between Makefile.plugin and Makefile :
# initialized them as "simply extended variables" (with :=)
# for a correct behavior of += (see section 6.6 of GNU Make manual)
PLUGIN_LIST	:=
PLUGIN_GENERATED_LIST:=
PLUGIN_CMO_LIST	:=
PLUGIN_CMX_LIST	:=
PLUGIN_META_LIST :=
PLUGIN_DYN_CMI_LIST :=
PLUGIN_DYN_CMO_LIST :=
PLUGIN_DYN_CMX_LIST :=
PLUGIN_INTERNAL_CMO_LIST:=
PLUGIN_INTERNAL_CMX_LIST:=
PLUGIN_GUI_CMO_LIST:=
PLUGIN_GUI_CMX_LIST:=
PLUGIN_DYN_DEP_GUI_CMO_LIST:=
PLUGIN_DYN_DEP_GUI_CMX_LIST:=
PLUGIN_DYN_GUI_CMO_LIST :=
PLUGIN_DYN_GUI_CMX_LIST :=
PLUGIN_TYPES_CMO_LIST :=
PLUGIN_TYPES_CMX_LIST :=
PLUGIN_DEP_LIST:=
PLUGIN_DOC_LIST :=
PLUGIN_DOC_DIRS :=
PLUGIN_DISTRIBUTED_LIST:=
PLUGIN_DIST_TARGET_LIST:=
PLUGIN_DIST_DOC_LIST:=
PLUGIN_BIN_DOC_LIST:=
PLUGIN_DIST_EXTERNAL_LIST:=
PLUGIN_DIST_TESTS_LIST:=
PLUGIN_DISTRIBUTED_NAME_LIST:=

PLUGIN_HEADER_SPEC_LIST :=
PLUGIN_HEADER_DIRS_LIST :=
PLUGIN_HEADER_EXCEPTIONS_LIST :=
PLUGIN_CEA_PROPRIETARY_HEADERS_LIST :=
PLUGIN_CEA_PROPRIETARY_FILES_LIST :=

# default value used for HEADER_SPEC and PLUGIN_HEADER_SPEC
DEFAULT_HEADER_SPEC := headers/header_spec.txt
# default value used for HEADER_DIRS and PLUGIN_HEADER_DIRS
DEFAULT_HEADER_DIRS := headers
# default value used for HEADER_EXCEPTIONS and PLUGIN_HEADER_EXCEPTIONS
DEFAULT_HEADER_EXCEPTIONS := configure
# default value used for CEA_PROPRIETARY_FILES and PLUGIN_CEA_PROPRIETARY_FILES
DEFAULT_CEA_PROPRIETARY_FILES := tests/non-free/%
# default value used for CEA_PROPRIETARY_HEADERS
# and PLUGIN_CEA_PROPRIETARY_HEADERS
DEFAULT_CEA_PROPRIETARY_HEADERS := CEA_PROPRIETARY

MERLIN_PACKAGES:=

###############################
# Additional global variables #
###############################

# Directories containing some source code
SRC_DIRS= ptests $(PLUGIN_LIB_DIR) $(FRAMAC_SRC_DIRS)

# Directory containing source code documentation
DOC_DIR	= doc/code

# Source files to document
MODULES_TODOC=

# Directories to include when compiling
INCLUDES=$(addprefix -I ,$(FRAMAC_SRC_DIRS)) -I $(PLUGIN_LIB_DIR)
ifneq ($(ENABLE_GUI),no)
GUI_INCLUDES = $(addprefix -package ,$(LIBRARY_NAMES_GUI))
else
GUI_INCLUDES =
endif

# Files for which dependencies must be computed.
# Other files are added later in this Makefile.
FILES_FOR_OCAMLDEP+=$(PLUGIN_LIB_DIR)/*.mli

BFLAGS	= $(PACKAGES) $(FLAGS) $(DEBUG) $(INCLUDES) \
		$(FRAMAC_USER_BFLAGS)
OFLAGS	= $(PACKAGES) $(FLAGS) $(DEBUG) $(INCLUDES) -compact \
		$(FRAMAC_USER_OFLAGS)

BLINKFLAGS += -linkpkg $(BFLAGS) -linkall -custom
OLINKFLAGS += -linkpkg $(OFLAGS) -linkall

DOC_FLAGS= -charset utf8 -colorize-code -stars -m A $(PACKAGES) $(INCLUDES) $(GUI_INCLUDES)

ifneq ($(VERBOSEMAKE),yes)
DOC_FLAGS+= -hide-warnings
endif

# Files that depend on external libraries -namely Zarith- whose interface
# has not been explicitely declared -opaque, hence would trigger warning 58.
# This can't be solved by Frama-C itself, we can only wait for an update of
# said library.

NON_OPAQUE_DEPS:=

# Libraries generated by Frama-C
GEN_BYTE_LIBS=
GEN_OPT_LIBS=

# Libraries used in Frama-C
EXTRA_OPT_LIBS:=
PACKAGES = $(addprefix -package ,$(LIBRARY_NAMES))
BYTE_LIBS = $(GEN_BYTE_LIBS)
OPT_LIBS = $(EXTRA_OPT_LIBS)

OPT_LIBS+= $(GEN_OPT_LIBS)

ICONS:= $(addprefix share/,\
		frama-c.ico frama-c.png unmark.png \
		switch-on.png switch-off.png)

THEME_ICON_NAMES:= \
		never_tried.png \
		unknown.png \
		surely_valid.png \
		surely_invalid.png \
		considered_valid.png \
		valid_under_hyp.png \
		invalid_under_hyp.png \
		invalid_but_dead.png \
		unknown_but_dead.png \
		valid_but_dead.png \
		inconsistent.png \
		fold.png unfold.png

THEME_ICONS_DEFAULT:= \
  $(addprefix share/theme/default/,$(THEME_ICON_NAMES))
THEME_ICONS_COLORBLIND:= \
  $(addprefix share/theme/colorblind/,$(THEME_ICON_NAMES))
THEME_ICONS_FLAT:= \
  $(addprefix share/theme/flat/,$(THEME_ICON_NAMES))

ROOT_LIBC_DIR:= share/libc
LIBC_SUBDIRS:= sys netinet net arpa
LIBC_DIR:= $(ROOT_LIBC_DIR) $(addprefix $(ROOT_LIBC_DIR)/,$(LIBC_SUBDIRS))
LIBC_FILES:= \
	$(wildcard share/*.h share/*.c) \
	$(wildcard $(addsuffix /*.h,$(LIBC_DIR))) \
	$(wildcard $(addsuffix /*.c,$(LIBC_DIR)))

# Checks that all .h can be included multiple times.
ALL_LIBC_HEADERS:=$(wildcard share/*.h $(addsuffix /*.h,$(LIBC_DIR)))

check-libc: bin/toplevel.$(OCAMLBEST)$(EXE)
	@echo "checking libc..."; \
	 EXIT_VALUE=0; \
	 for file in $(filter-out share/builtin.h,$(ALL_LIBC_HEADERS)); do \
	   echo "#include \"$$file\"" > check-libc.c; \
	   echo "#include \"$$file\"" >> check-libc.c; \
	   FRAMAC_SHARE=share bin/toplevel.$(OCAMLBEST)$(EXE) \
	   -cpp-extra-args="-Ishare/libc -nostdinc" check-libc.c \
	       > $$(basename $$file .h).log 2>&1; \
	   if test $$? -ne 0; then \
	     if grep -q -e '#error "Frama-C:' $$file; then : ; \
	     else \
	       echo "$$file cannot be included twice. \
Output is in $$(basename $$file .h).log"; \
	       EXIT_VALUE=1; \
	     fi; \
	   else \
	     rm $$(basename $$file .h).log; \
	   fi; \
	 done; \
	 rm check-libc.c; \
	 exit $$EXIT_VALUE

clean-check-libc:
	$(RM) *.log

# Kernel files to be included in the distribution.
# Plug-ins should use PLUGIN_DISTRIB_EXTERNAL if they export something else
# than *.ml* files in their directory.
# NB: configure for the distribution is generated in the distrib directory
# itself, rather than copied: otherwise, it could include references to
# non-distributed plug-ins.
DISTRIB_FILES:=\
      $(wildcard bin/migration_scripts/*2*.sh) bin/local_export.sh      \
      bin/frama-c bin/frama-c.byte bin/frama-c-gui bin/frama-c-gui.byte \
      bin/frama-c-config bin/frama-c-script                             \
      share/frama-c.WIN32.rc share/frama-c.Unix.rc                      \
      $(ICONS) $(THEME_ICONS_DEFAULT) $(THEME_ICONS_COLORBLIND)         \
      $(THEME_ICONS_FLAT)                                               \
      man/frama-c.1 doc/README						\
      doc/code/docgen.ml                                                \
      $(wildcard doc/code/*.css) doc/code/intro_plugin.txt              \
      doc/code/intro_plugin_D_and_S.txt                                 \
      doc/code/intro_plugin_default.txt                                 \
      doc/code/intro_kernel_plugin.txt					\
      doc/code/toc_head.htm                                             \
      doc/code/toc_tail.htm                                             \
      doc/Makefile                                                      \
      $(filter-out ptests/ptests_config.ml,$(wildcard ptests/*.ml*))   \
      configure.in Makefile Makefile.generating				\
      Changelog config.h.in						\
      VERSION VERSION_CODENAME $(wildcard licenses/*)                   \
      $(LIBC_FILES)							\
      share/analysis-scripts/analysis.mk                                \
      share/analysis-scripts/benchmark_database.py                      \
      share/analysis-scripts/build.py                                   \
      share/analysis-scripts/build_callgraph.py                         \
      share/analysis-scripts/cmd-dep.sh                                 \
      share/analysis-scripts/concat-csv.sh                              \
      share/analysis-scripts/clone.sh                                   \
      share/analysis-scripts/creduce.sh                                 \
      share/analysis-scripts/detect_recursion.py                        \
      share/analysis-scripts/epilogue.mk                                \
      share/analysis-scripts/estimate_difficulty.py                     \
      share/analysis-scripts/fc_stubs.c                                 \
      share/analysis-scripts/find_fun.py                                \
      share/analysis-scripts/flamegraph.pl                              \
      share/analysis-scripts/frama_c_results.py                         \
      share/analysis-scripts/function_finder.py                         \
      share/analysis-scripts/git_utils.py                               \
      share/analysis-scripts/heuristic_list_functions.py                \
      share/analysis-scripts/list_files.py                              \
      share/analysis-scripts/list_functions.ml                          \
      share/analysis-scripts/make_wrapper.py                            \
      share/analysis-scripts/normalize_jcdb.py                          \
      share/analysis-scripts/parse-coverage.sh                          \
      share/analysis-scripts/print_callgraph.py                         \
      share/analysis-scripts/prologue.mk                                \
      share/analysis-scripts/pyproject.toml                             \
      share/analysis-scripts/README.md                                  \
      share/analysis-scripts/results_display.py                         \
      share/analysis-scripts/script_for_creduce_fatal.sh                \
      share/analysis-scripts/script_for_creduce_non_fatal.sh            \
      share/analysis-scripts/source_filter.py                           \
      share/analysis-scripts/summary.py                                 \
      share/analysis-scripts/template.mk                                \
      $(wildcard share/emacs/*.el) share/autocomplete_frama-c           \
      share/_frama-c                                                    \
      share/compliance/c11_functions.json                               \
      share/compliance/c11_headers.json                                 \
      share/compliance/compiler_builtins.json                           \

=== doc/Makefile ===
##########################################################################
#                                                                        #
#  This file is part of Frama-C.                                         #
#                                                                        #
#  Copyright (C) 2007-2022                                               #
#    CEA (Commissariat à l'énergie atomique et aux énergies              #
#         alternatives)                                                  #
#                                                                        #
#  you can redistribute it and/or modify it under the terms of the GNU   #
#  Lesser General Public License as published by the Free Software       #
#  Foundation, version 2.1.                                              #
#                                                                        #
#  It is distributed in the hope that it will be useful,                 #
#  but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#  GNU Lesser General Public License for more details.                   #
#                                                                        #
#  See the GNU Lesser General Public License version 2.1                 #
#  for more details (enclosed in the file licenses/LGPLv2.1).            #
#                                                                        #
##########################################################################

# default when make is invoked without target
default:

FRAMAC_SRC=..
MAKECONFIG_DIR=$(FRAMAC_SRC)/share

include $(FRAMAC_SRC)/share/Makefile.common

DOCDIR ?= "$(DESTDIR)${prefix}/share/doc"
FRAMAC_DOCDIR ?= $(DOCDIR)/frama-c

.PHONY: .force


###################
# Frama-C Version #
###################

VERSION=$(shell $(SED) -e 's/\\(.*\\)/\\1/' $(FRAMAC_SRC)/VERSION)
VERSION_CODENAME=$(shell cat $(FRAMAC_SRC)/VERSION_CODENAME)
VERSION_SAFE=$(subst ~,-,$(VERSION))

ifeq ($(findstring +dev,$(VERSION)),+dev)

# Developpement version, generate the manuals
default: all

else

# Distributed version, download the manuals by default
default: download

MANUALS=acsl

#MANUALS that depend on the frama-c version
VERSIONED_MANUALS=acsl-implementation aorai-manual rte-manual	\
		  wp-manual metrics-manual user-manual		\
		  plugin-development-guide eva-manual

FILES= $(addprefix manuals/, \
	 $(addsuffix -$(VERSION).pdf, $(VERSIONED_MANUALS)) \
         $(addsuffix .pdf, $(MANUALS)) \
	)

download: .force
	$(MKDIR) manuals
	wget -nv -N -P manuals \
	  $(addprefix http://frama-c.com/download/,$(addsuffix -$(VERSION).pdf, $(VERSIONED_MANUALS))) \
	  $(addprefix http://frama-c.com/download/,$(addsuffix .pdf, $(MANUALS)))

install:
	$(MKDIR) $(FRAMAC_DOCDIR)
	$(CP) $(FILES) $(FRAMAC_DOCDIR)

endif


###################
# Generation      #
###################

FC_SUFFIX=$(VERSION_SAFE)-$(VERSION_CODENAME)

clean::
	$(RM) manuals/*.pdf
	$(RM) manuals/*.tgz
	$(MAKE) -C userman clean
	$(MAKE) -C developer clean
	$(MAKE) -C rte clean
	$(MAKE) -C aorai clean
	$(MAKE) -C value clean
	$(MAKE) -C metrics clean
	$(MAKE) -C ../src/plugins/wp/doc/manual clean

all: \
	manuals/user-manual-$(FC_SUFFIX).pdf \
	manuals/plugin-development-guide-$(FC_SUFFIX).pdf \
	manuals/rte-manual-$(FC_SUFFIX).pdf \
	manuals/aorai-manual-$(FC_SUFFIX).pdf \
	manuals/aorai-example-$(FC_SUFFIX).tgz \
	manuals/eva-manual-$(FC_SUFFIX).pdf \
	manuals/metrics-manual-$(FC_SUFFIX).pdf \
	manuals/wp-manual-$(FC_SUFFIX).pdf \

manuals/%:
	mkdir --parent manuals
	$(CP) $< $@

%.pdf: 
	$(PRINT) Generating $@
	$(MAKE) -C $(@D) $(@F)

%.tgz: 
	$(PRINT) Generating $@
	$(MAKE) -C $(@D) $(@F)

manuals/user-manual-$(FC_SUFFIX).pdf: userman/userman.pdf
manuals/plugin-development-guide-$(FC_SUFFIX).pdf: developer/developer.pdf
manuals/rte-manual-$(FC_SUFFIX).pdf: rte/main.pdf
manuals/aorai-manual-$(FC_SUFFIX).pdf: aorai/main.pdf
manuals/aorai-example-$(FC_SUFFIX).tgz: aorai/aorai-example.tgz
manuals/eva-manual-$(FC_SUFFIX).pdf: value/main.pdf
manuals/metrics-manual-$(FC_SUFFIX).pdf: metrics/metrics.pdf
manuals/wp-manual-$(FC_SUFFIX).pdf: ../src/plugins/wp/doc/manual/wp.pdf


###################
# ACSL            #
###################

ifeq ($(wildcard acsl),)

# ACSL and E-ACSL manuals requires a clone of the acsl repository
$(info 'acsl' not in doc; try: git clone https://github.com/acsl-language/acsl.git)

else

ACSL_SUFFIX=$(shell grep acslversion acsl/version.tex | sed 's/.*{\([^{}\\]*\).*/\1/')

clean::
	$(MAKE) -C acsl clean

all: \
	manuals/acsl-implementation-$(FC_SUFFIX).pdf \
	manuals/acsl-$(ACSL_SUFFIX).pdf \

manuals/acsl-implementation-$(FC_SUFFIX).pdf: acsl/acsl-implementation.pdf
manuals/acsl-$(ACSL_SUFFIX).pdf: acsl/acsl.pdf


###################
# E-ACSL          #
###################

EACSL_DOC=../src/plugins/e-acsl/doc
EACSL_SUFFIX=$(shell grep 'newcommand{\\eacsllangversion' $(EACSL_DOC)/refman/main.tex | sed 's/.*{\([^{}\\]*\).*/\1/')

ifeq ($(EACSL_SUFFIX),)   

$(info could not retrieve E-ACSL version from ../src/plugins/e-acsl/doc/refman/main.tex")

else

# Sanity check: version differences between Frama-C, and E-ACSL
ifneq ($(ACSL_SUFFIX),$(EACSL_SUFFIX))
    $(info WARNING: different versions for ACSL and E-ACSL manuals: $(ACSL_SUFFIX) versus $(EACSL_SUFFIX))
endif

clean::
	$(MAKE) -C $(EACSL_DOC)/refman/ clean
	$(MAKE) -C $(EACSL_DOC)/userman/ clean

all: \
	manuals/e-acsl-implementation-$(FC_SUFFIX).pdf \
	manuals/e-acsl-manual-$(FC_SUFFIX).pdf \
	manuals/e-acsl-$(EACSL_SUFFIX).pdf \

manuals/e-acsl-implementation-$(FC_SUFFIX).pdf: $(EACSL_DOC)/refman/e-acsl-implementation.pdf
manuals/e-acsl-manual-$(FC_SUFFIX).pdf: $(EACSL_DOC)/userman/main.pdf
manuals/e-acsl-$(EACSL_SUFFIX).pdf: $(EACSL_DOC)/refman/e-acsl.pdf

endif

# Note: The makefiles of ACSL/E-ACSL are not parallelizable when producing both
# acsl.pdf and acsl-implementation.pdf (race conditions in intermediary files,
# leading to non-deterministic errors): we have to wait for one to complete
# before making the other

acsl/acsl-implementation.pdf: | acsl/acsl.pdf
$(EACSL_DOC)/refman/e-acsl-implementation.pdf: | $(EACSL_DOC)/refman/e-acsl.pdf

endif

=== ivette/Makefile ===
##########################################################################
#                                                                        #
#  This file is part of Frama-C.                                         #
#                                                                        #
#  Copyright (C) 2007-2022                                               #
#    CEA (Commissariat à l'énergie atomique et aux énergies              #
#         alternatives)                                                  #
#                                                                        #
#  you can redistribute it and/or modify it under the terms of the GNU   #
#  Lesser General Public License as published by the Free Software       #
#  Foundation, version 2.1.                                              #
#                                                                        #
#  It is distributed in the hope that it will be useful,                 #
#  but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#  GNU Lesser General Public License for more details.                   #
#                                                                        #
#  See the GNU Lesser General Public License version 2.1                 #
#  for more details (enclosed in the file licenses/LGPLv2.1).            #
#                                                                        #
##########################################################################

# --------------------------------------------------------------------------
APP=Ivette
DOME=./src/dome
DOME_ARGS=--command $$(dirname $$0)/../../bin/frama-c
DOME_DEV=-server-debug 1
DOME_CLI=./bin/ivette
DOME_API=./src/frama-c
DOME_CUSTOM_ENTRIES= yes
COPYRIGHT=CEA LIST / LSL
# --------------------------------------------------------------------------

.PHONY: all app dev pkg doc serve dist lint fixlint checkcase

all: pkg lint app

app: dome-app
dev: dome-dev
dist: dist-dir dome-dist

lint: dome-pkg dome-templ checkcase
	@echo "[Ivette] running typechecker & linter"
	yarn run typecheck
	yarn run lint

# In case-insensitive filesystems (macOS/Windows), import statements and
# filenames can have issues due to case differences
checkcase:
	@echo "[Ivette] check case issues in imported filenames"
	@err=0 ; for f in `find src | sed -E 's/(.ts|.tsx|.js|.jsx|.css|.json)$$//' | sort -f | uniq -di` ;\
	 do \
		err=1; \
		echo " - ambiguous $$f.*"; \
	 done ;\
	 exit $$err

tsc: dome-pkg dome-templ
	@echo "[Ivette] running typechecker & linter (with cache & fix mode)"
	yarn run typecheck
	yarn run lint --fix --cache --cache-location .eslint-cache

# --------------------------------------------------------------------------
# --- Ivette Package Loader
# --------------------------------------------------------------------------

LOADER=src/renderer/loader.ts
PACKAGES=$(shell find src -name "pkg.json")

lint: pkg
dome-pkg: pkg
dome-app: pkg
dome-dev: pkg
dome-dist: pkg
pkg: $(LOADER)
$(LOADER): $(PACKAGES) ./configure.js ./Makefile
	@rm -f $(LOADER)
	@echo "[Ivette] configure packages"
	@node ./configure.js $(LOADER) $(PACKAGES)
	@chmod -f a-w $(LOADER)

# --------------------------------------------------------------------------
# --- Frama-C Source Distrib
# --------------------------------------------------------------------------

.PHONY: update-distrib-files

update-distrib-files:
	./distrib.sh

# --------------------------------------------------------------------------
# --- Frama-C API
# --------------------------------------------------------------------------

.PHONY: api

api:
	@echo "[Ivette] Generating TypeScript API"
	@find src/frama-c -path "*/api/*" -name "*.ts" -exec rm -f {} \;
	../bin/frama-c.byte \
		-load-module src/frama-c/api_generator.ml \
		-server-tsc
	@find src/frama-c -path "*/api/*" -name "*.ts" \
		-exec headache \
			-h ../headers/open-source/CEA_LGPL \
			-c ../headers/headache_config.txt {} \;\
		-exec chmod a-w {} \;

# --------------------------------------------------------------------------
# --- Ivette Documentation
# --------------------------------------------------------------------------

.PHONY: icons

VERSION=$(shell echo "console.log(require('./package.json').version)" | node -)

DOC_ICONS_CSS= src/dome/doc/gallery.css
DOC_ICONS_MAKE= src/dome/doc/iconsmd.js
DOC_ICONS_GALLERY= src/dome/doc/guides/icons.md
DOC_ICONS_DATA= src/dome/renderer/controls/gallery.json
DOC_GUIDES= src/dome/doc/guides

NODEBIN= ./node_modules/.bin

DOCDIRS= src/ivette src/dome/renderer src/dome/utils src/frama-c/api
DOCFILES= src/frama-c/server.ts src/frama-c/states.ts $(shell find $(DOCDIRS) -name "*.ts" -or -name "*.tsx")

icons: $(DOC_ICONS_GALLERY)

$(DOC_ICONS_GALLERY): $(DOC_ICONS_MAKE) $(DOC_ICONS_DATA)
	@rm -f $@
	@node $(DOC_ICONS_MAKE) $(DOC_ICONS_DATA) > src/dome/doc/guides/icons.md
	@chmod a-w $@

doc: $(NODEBIN)/typedoc icons
	@echo "\n[Ivette] documentation"
	@rm -fr doc/html
	@yarn run typedoc $(DOCFILES)
	@echo "\n[Ivette] main page"
	@echo ""
	@echo "   file://$(PWD)/ivette/doc/html/index.html"
	@echo ""

$(NODEBIN)/%:
	@echo "[Node] install package $*"
	yarn add -D $*

# --------------------------------------------------------------------------
include $(DOME)/template/makefile
# --------------------------------------------------------------------------

# --------------------------------------------------------------------------
# --- Ivette Installation
# --------------------------------------------------------------------------

sinclude ../share/Makefile.config

dist-dir:
	@echo "Cleaning dist"
	@rm -fr dist

IVETTE_DIST=$(wildcard dist/linux-unpacked dist/mac dist/mac-arm64)

ifdef LIBDIR
ifdef BINDIR
ifeq ($(IVETTE_DIST),dist/linux-unpacked)

install:
	@echo "Installing Ivette (Linux)"
	@rm -fr $(LIBDIR)/ivette
	@rm -f $(BINDIR)/ivette
	@mv $(IVETTE_DIST) $(LIBDIR)/ivette
	@ln -s $(LIBDIR)/ivette/ivette $(BINDIR)/ivette

else ifeq ($(IVETTE_DIST:-arm64=),dist/mac)

install:
	@echo "Installing Ivette (macOS)"
	@rm -fr /Applications/Ivette.app
	@mv $(IVETTE_DIST)/Ivette.app /Applications/
	@rm -fr $(IVETTE_DIST)
	@install ivette-macos.sh $(BINDIR)/ivette

else

install:
	@echo "No distribution to install"
	@echo "use 'make dist' and retry"
	@exit 1

endif
endif
endif

# --------------------------------------------------------------------------
# --- Ivette Un-Installation
# --------------------------------------------------------------------------

ifdef LIBDIR
ifdef BINDIR

uninstall:
	@echo "Uninstall Ivette"
	@rm -fr dist
	@rm -fr /Applications/Ivette.app
	@rm -fr $(LIBDIR)/ivette
	@rm -f $(BINDIR)/ivette

endif
endif

# --------------------------------------------------------------------------

=== src/plugins/print_api/Makefile ===
##########################################################################
#                                                                        #
#  This file is part of Frama-C.                                         #
#                                                                        #
#  Copyright (C) 2007-2022                                               #
#    CEA (Commissariat à l'énergie atomique et aux énergies              #
#         alternatives)                                                  #
#                                                                        #
#  you can redistribute it and/or modify it under the terms of the GNU   #
#  Lesser General Public License as published by the Free Software       #
#  Foundation, version 2.1.                                              #
#                                                                        #
#  It is distributed in the hope that it will be useful,                 #
#  but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#  GNU Lesser General Public License for more details.                   #
#                                                                        #
#  See the GNU Lesser General Public License version 2.1                 #
#  for more details (enclosed in the file licenses/LGPLv2.1).            #
#                                                                        #
##########################################################################

# Print_api plugin
##################

# Frama-C should be properly installed with "make install"
# befor any use of this makefile

ifndef FRAMAC_SHARE
FRAMAC_SHARE	:=$(shell frama-c.byte -print-path)
endif
ifndef FRAMAC_LIBDIR
FRAMAC_LIBDIR	:=$(shell frama-c.byte -print-libpath)
endif

PLUGIN_DIR	?= .
PLUGIN_NAME	:= Print_api
PLUGIN_CMO	:= grammar lexer print_interface
PLUGIN_GENERATED:= $(PLUGIN_DIR)/grammar.ml $(PLUGIN_DIR)/grammar.mli \
		$(PLUGIN_DIR)/lexer.ml
PLUGIN_DISTRIB_EXTERNAL:=Makefile

include $(FRAMAC_SHARE)/Makefile.dynamic

clean:: 
	$(RM) $(Print_api_DIR)/dynamic_plugins.mli
	$(RM) $(Print_api_DIR)/grammar.output
	$(RM) $(Print_api_DIR)/grammar.ml
	$(RM) $(Print_api_DIR)/grammar.mli
	$(RM) $(Print_api_DIR)/lexer.ml
	$(RM) -r _build

=== ivette/src/dome/examples/Makefile ===
##########################################################################
#                                                                        #
#  This file is part of Frama-C.                                         #
#                                                                        #
#  Copyright (C) 2007-2022                                               #
#    CEA (Commissariat à l'énergie atomique et aux énergies              #
#         alternatives)                                                  #
#                                                                        #
#  you can redistribute it and/or modify it under the terms of the GNU   #
#  Lesser General Public License as published by the Free Software       #
#  Foundation, version 2.1.                                              #
#                                                                        #
#  It is distributed in the hope that it will be useful,                 #
#  but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#  GNU Lesser General Public License for more details.                   #
#                                                                        #
#  See the GNU Lesser General Public License version 2.1                 #
#  for more details (enclosed in the file licenses/LGPLv2.1).            #
#                                                                        #
##########################################################################

# --------------------------------------------------------------------------
help:
	@echo "*****************************************"
	@echo "***      Dome Framework Makefile      ***"
	@echo "*****************************************"
	@echo
	@echo "   make doc: alias for dome-doc"
	@echo "   make dev: alias for dome-dev"
	@echo "   make app: alias for dome-app"
	@echo "   make dist: alias for dome-dist"
	@echo "   make dome-help: detailed help for dome"
	@echo "   make DEMO=<xxx> demo: switch to 'src/renderer/demo/xxx.js' "
	@echo
	@echo "*****************************************"

# --------------------------------------------------------------------------

APP=Dome
DOME=.
DEMO=Hello

include $(DOME)/template/makefile

.PHONY: doc demo dev app dist

doc: dome-doc
dev: dome-dev
app: dome-app
dist: dome-dist

demo: src/renderer/demo/$(DEMO).js
	@echo "Switch to src/renderer/demo/$(DEMO).js"
	@rm -f src/renderer/Application.js
	@echo "// Dome Demonstrator" >> src/renderer/Application.js
	@echo "import React from 'react' ;"  >> src/renderer/Application.js
	@echo "import Main from './demo/$(DEMO).js' ;" >> src/renderer/Application.js
	@echo "export default (() => <Main/>);" >> src/renderer/Application.js

src/renderer/demo/%.js:
	@echo "Generate  $@"
	@echo "// Dome Demonstrator" > $@
	@echo "import React from 'react';" >> $@
	@echo "export default (() => <h1>$* Demo</h1>);" >> $@

# --------------------------------------------------------------------------

## frama-c 20220511-manganese

=== debian/changelog ===
frama-c (20220511-manganese-5build7) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 05:18:58 +0000

frama-c (20220511-manganese-5build6) noble; urgency=medium

  * No-change rebuild against libglib2.0-0t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 08 Mar 2024 04:22:00 +0000

frama-c (20220511-manganese-5build5) noble; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 22 Feb 2024 08:36:38 +0100

frama-c (20220511-manganese-5build4) noble; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 19 Feb 2024 07:57:00 +0100

frama-c (20220511-manganese-5build3) noble; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 17 Feb 2024 01:23:27 +0100

frama-c (20220511-manganese-5build2) noble; urgency=medium

  * Rebuild against 'new OCAML ABIs'.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 15 Dec 2023 07:55:32 +0100

frama-c (20220511-manganese-5build1) noble; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 04 Nov 2023 20:12:29 +0100

frama-c (20220511-manganese-5) unstable; urgency=medium

  [ Stéphane Glondu ]
  * Team upload
  * Disable Why3 support (Closes: #1051485)
  * Depend on ocaml instead of transitional ocaml-nox

  [ Debian Janitor ]
  * Remove constraints unnecessary since buster (oldstable):
    + Build-Depends: Drop versioned constraint on dh-ocaml (>= 0.9~).
    + Build-Depends: Drop versioned constraint on libocamlgraph-ocaml-dev (>=
      1.8.8).

 -- Stéphane Glondu <glondu@debian.org>  Sat, 09 Sep 2023 08:26:56 +0200

frama-c (20220511-manganese-4) unstable; urgency=medium

  [ Stéphane Glondu ]
  * Team upload
  * Fix compilation with recent yojson (Closes: #1040537)

  [ Debian Janitor ]
  * debian/copyright: use spaces rather than tabs to start continuation lines.

 -- Stéphane Glondu <glondu@debian.org>  Thu, 13 Jul 2023 09:10:19 +0200

frama-c (20220511-manganese-3) unstable; urgency=medium

  * Create a versioned dependency on libwhy3-ocaml-dev (closes: #1023712).
    As a consequence, remove dependency on libwhy3-ocaml-dev in the tests.
  * Standards-Version 4.6.2 (no change)

 -- Ralf Treinen <treinen@debian.org>  Tue, 27 Dec 2022 21:00:26 +0100

frama-c (20220511-manganese-2) unstable; urgency=medium

  * Fix properly the failing autopkgtest "wp" : spurious warning by "why3
    config" has to be sent to /dev/null.

 -- Ralf Treinen <treinen@debian.org>  Sun, 23 Oct 2022 12:25:38 +0200

frama-c (20220511-manganese-1.3) unstable; urgency=medium

  * Tighten the dep on newer why3 also for autopkgtest.

 -- Julien Puydt <jpuydt@debian.org>  Mon, 27 Jun 2022 20:50:40 +0200

frama-c (20220511-manganese-1.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Tighten the dep on newer why3.

 -- Julien Puydt <jpuydt@debian.org>  Mon, 27 Jun 2022 11:29:05 +0200

frama-c (20220511-manganese-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Add crude dep on libppx-import-ocaml by hand (why does dh-ocaml
  fail to detect it?).
  * Add workaround for failing autopkgtest.

 -- Julien Puydt <jpuydt@debian.org>  Thu, 23 Jun 2022 11:46:20 +0200

frama-c (20220511-manganese-1) unstable; urgency=medium

  * New upstream version. This version is compatible with why3 version
    1.5.0 (closes: #1011892,#1010867).
  * Add build-dependency on
    - libppx-import-ocaml-dev
    - libppx-deriving-ocaml-dev
  * debian/copyright: drop mention of plugins that are no longer
    included in the upstream distribution:
    - coqwp
    - ergo
  * Standards-Version 4.6.1 (no change)

 -- Ralf Treinen <treinen@debian.org>  Sat, 18 Jun 2022 19:39:11 +0200

frama-c (20211203-chromium-1) unstable; urgency=medium

  * New upstream release. This release fixes FTBFS with why3 >= 1.4.0
    (closes: #1000491)
    - drop patch 0001-E-ACSL-avoid-cmx-dependencies-when-in-a-byte-only-ar
      which has been applied upstream.
    - refresh remaining patches
  * install: move libeacsl-dlmalloc.a from usr/lib to usr/lib/frama-c/e-acsl
  * d/copyright: remove some file patterns that no longer apply.
  * d/tests/wp: update call to "why3 config"
  * Standards-Version 4.6.0 (no change)

 -- Ralf Treinen <treinen@debian.org>  Tue, 22 Mar 2022 08:02:03 +0100

=== debian/control ===
Source: frama-c
Section: devel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders: Mehdi Dogguy <mehdi@debian.org>,
 Ralf Treinen <treinen@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 ocaml,
 dh-ocaml,
 graphviz,
 autoconf,
 libzarith-ocaml-dev,
 ocaml-findlib,
 libfindlib-ocaml-dev,
 libyojson-ocaml-dev,
 libocamlgraph-ocaml-dev,
 liblablgtk3-ocaml-dev (>= 3.0~beta4),
 liblablgtksourceview3-ocaml-dev,
 libppx-import-ocaml-dev,
 libppx-deriving-ocaml-dev
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://frama-c.com
Vcs-Browser: https://salsa.debian.org/ocaml-team/frama-c
Vcs-Git: https://salsa.debian.org/ocaml-team/frama-c.git

Package: frama-c-base
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 ${ocaml:Depends},
 ${perl:Depends},
 libocamlgraph-ocaml-dev, libppx-import-ocaml,
 gcc,
 python3
Recommends:
 alt-ergo, why3
Description: Platform dedicated to the analysis of source code written in C
 Frama-C gathers several analysis techniques in a single collaborative
 framework, based on analyzers (called "plug-ins") that can build upon the
 results computed by other analyzers in the framework.
 .
 Thanks to this approach, Frama-C provides sophisticated tools, including:
   * an analyzer based on abstract interpretation (Value plug-in);
   * a program proof framework based on weakest precondition calculus
     (WP plug-in);
   * a program slicer (Slicing plug-in);
   * a tool for verification of temporal (LTL) properties (Aoraï plug-in);
   * several tools for code base exploration and dependency analysis
     (plug-ins From, Impact, Metrics, Occurrence, Scope, etc.).
 .
 These plug-ins communicate between each other via the Frama-C API
 and via ACSL (ANSI/ISO C Specification Language) properties.
 .
 This package provides the library of Frama-c which is useful to build
 plugins for Frama-c, the command-line tools, and the graphical interface.

=== debian/tests/control ===
Tests: eva
Depends: frama-c-base

Tests: wp
Depends: frama-c-base, alt-ergo (>= 2.0.0), why3
Restrictions: skip-not-installable
